/*
  Projekt: Jak na projekty v jazyce C

  Zkladn konstrukce jazyka C
  Lekce 2 - pole, textov etzce, cykly

  Autor: David Martinek, martinek (zavin) fit.vutbr.cz
  Datum: 06.03.2009
  Kdovn dokumentu: ISO8859-2
  Popis: Tento program slou pro demonstraci zkladnch stavebnch prvk
         jazyka C.
  Webov adresa: http://www.fit.vutbr.cz/~martinek/clang/
*/

// Jak st tento zdrojov soubor
// 1. Zante sekc pro vkldn rozhran knihoven.
// 2. Podvejte se na funkci main, kter se nachz na konci souboru.
// 3. Ve funkci main se v uritm poad volaj jednotliv podprogramy.
//    V tom poad, v jakm se volaj ve funkci main, si prohldnte jejich
//    definice v prostedn sti zdrojovho souboru. Ped kadou funkc se
//    nachz koment, kter vysvtluje, co se v tto funkci dje.
// 4. Pelote tento zdrojov soubor pomoc pekladae jazyka C. Na webovch
//    strnkch Jak na projekty v jazyce C najdete postup, jak peklada
//    zavolat.
//    Tak mete pout pkaz make. Makefile je pibalen. Pokud nerozumte,
//    co to znamen, pette si o programu make na webovch strnkch.


////////// Sekce pro vkldn rozhran knihoven ///////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


///////// Definice konstant ///////////////////////////////////////////////////
// symbolick konstanta N obsahujc hodnotu 5, budeme ji pouvat pro
// specifikaci rozmr pol
// TIP: vimnte si, e zde nen nikde stednk ani rovntko
// TIP: podvejte se na tuto konstrukci do njak uebnice jazyka C
#define N 5

// symbolick konstanta obsahujc hodnotu 7
#define M 7

///////// Definice podprogram ////////////////////////////////////////////////

//== zatek == pole - inicializace a tisk na obrazovku ==
/**
 * Funkce, kter vyrob jednorozmrn pole, napln jej hodnotami a vytiskne
 * jeho obsah na obrazovku.
 */
void tiskPoleMocnin(void)
{
  int pole[N]; // deklarace + definice lokln promnn - pole o pti prvcch
               // kad prvek tohoto pole je promnn typu int

  // cyklus pro naplnn pole hodnotami
  // i - index pole, v tomto ppad bude postupn nabvat hodnot 0, 1, 2, 3 a 4
  // POZOR: v jazyce C se pole indexuj od nuly a NIKDY jinak
  for (int i = 0; i < N; ++i)
  {
    pole[i] = i*i; // do kadho prvku vlome druhou mocninu indexu
  }

  // tisk pole na standardn vstup
  // nelze tisknout cel pole najdenou, musme tisknout po jednotlivch prvcch
  for (int i = 0; i < N; ++i)
  {
    printf("pole[%d] = %d\n", i, pole[i]);
  }
}

/**
 * Abychom nemuseli kad pole tisknout run, vyrobme si funkci, kter um
 * vytisknout pole zadan jako parametr. Protoe si datov typ pole neum
 * zapamatovat svou dlku, musme dlku pole dodat jako druh parametr.
 *
 * pole - jednorozmrn pole s prvky typu int, vimnte si, e hranat
 *        zvorky jsou przdn, rozmr dodme dalm parametrem
 * delka - dlka pole, tedy poet jeho prvk
 *
 * TIP: Vimnte si, v jakm formtu funce vytiskne pole na vstup. Stejnou
 * formu zpisu lze pout i v jazyce C pro inicializaci pole pi definici
 * promnn.
 */
void tiskPole(int pole[], int delka)
{
  printf("{ ");
  for (int i = 0; i < delka; ++i)
  {
    printf("[%d]=%d, ", i, pole[i]);
  }
  printf("}\n");
}
// Poznmka: pole se v jazyce C pedv vdy jako ukazatel na jeho zatek.
// V jazyce C nelze pedat pole hodnotou. To znamen, e vdy kdy modifikujeme
// njak prvek pole pedanho jako parametr, zstane tato zmna v poli
// zachovna i po skonen tto funkce.

// Poznmka: Protoe pracujeme s jednorozmrnm polem a pro jazyk C jsou pole
// a ukazatele velmi pbuzn datov typy (viz uebnice jazyka C), mohla by
// hlavika pedchoz funkce vypadat i takto, ani by se jakkoli zmnil jej
// vznam:
// void tiskPole(int *pole, int delka)

/**
 * Demonstrace rznch zpsob vytven a inicializac jednorozmrnch pol.
 * Nyn pro tisk pouijeme funkci tiskPole.
 *
 * Vimnte si, e se pole pedv zdnliv hodnotou, akoliv pedchoz poznmky
 * kaj, e se pole pedv jako ukazatel. Je to tak proto, e vlastn
 * pedvme hodnotou ukazatel na zatek pole - tento ukazatel nechceme mnit,
 * ppadn zmny by se tkaly prvk pole, nikoli ukazatele na jeho zatek.
 * Ble viz uebnice jazyka C.
 */
void tiskniLany(void)
{
  // neinicializovan pole dlky N
  // prvky nyn mohou mt libovolnou hodnotu
  // i kdy asto bude jejich hodnota nula, nelze se na to spolhat!
  int pole1[N];
  printf("Neinicializovan pole: ");
  tiskPole(pole1, N);

  // inicializace pomoc inicializtoru pole
  // Poet prvk nyn nen poteba zadvat, protoe se dopot
  // z inicializtoru.
  int pole2[] = {2, 4, 6, 8};
  printf("Inicializtor 1: ");
  tiskPole(pole2, 4);

  // pokud zadme rozmr a inicializujeme jenom nkter prvky, ostatn prvky
  // budou mt automaticky hodnotu nula
  // POZOR! Tohle plat jen pi pouit inicializtoru, bez nj jsou vechny
  // prvky neinicializovan a maj tud nezaruitelnou hodnotu!
  int pole3[7] = {1, 4, 9};
  printf("Inicializtor 2: ");
  tiskPole(pole3, 7);

  // v inicializtoru lze pout i index, hod se to zejmna u dlouhch
  // pol, v nich chceme inicializovat jen vybran hodnoty
  // vimnte si, na jakch pozicch jsou prvky bez uvedenho indexu
  // nevyjmenovan prvky jsou zde inicializovny na nulu
  // Poznmka: tohle ve starch verzch jazyka C dlat nejde
  int pole4[7] = {1, 4, [3]=16, 25};
  printf("Inicializtor 2: ");
  tiskPole(pole4, 7);

  // dal monost je inicializovat pole pomoc cyklu, jak bylo demonstrovno
  // ve funkci tiskPoleMocnin
}

/**
 * Funkce pro tisk dvojrozmrnch pol.
 *
 * Matice nebo 2D pole je vlastn polem jednorozmrnch pol. Ze stejnho
 * dvodu, jako u jednorozmrnch pol lze zde nechat prvn hranat zvorky,
 * tedy poet dk pole, przdn. Poet dk je nutn pedat jako dal
 * parametr. Dal dimenzi je ovem naopak NUTN uvst, aby peklada vdl,
 * jak dlouh jsou dky, z jeho pohledu tedy prvky jednoprvkovho pole.
 *
 * TIP: Vimnte si, v jakm formtu funkce tiskne matici na vstup.
 * Stejnou formu zpisu lze pout i v jazyce C pro inicializace vcerozmrnch
 * pol pi definicch promnnch. V podstat jde o sloen inicializtor
 * jednorozmrnho pole.
 *
 * POZOR! Tato funkce je pouze ukzkov. V praxi je tento zpsob prce s matic
 * z nkolika dvod krajn NEVHODN a tkopdn. Mnohem vhodnj je pouvat
 * dynamicky alokovan pole zabalen spolu s rozmry ve struktue. Ble viz
 * uebnice jazyka C.
 */
void tiskMatice(int matice[][N], int radku)
{
  printf("{\n");
  for (int r = 0; r < radku; ++r)
  {
    printf("  { ");
    for (int s = 0; s < N; ++s)
    {
      printf("%d, ", matice[r][s]);
    }
    printf("},\n");
  }
  printf("}\n");
}

/**
 * Demonstrace vytven a inicializac dvojrozmrnch pol, tedy matic.
 * Matice je v jazyce C chpna jako pole jednorozmrnch pol, neboli pole
 * dk. Prvn rozmr obvykle udv poet dk, druh rozmr poet sloupc
 * (tedy dlku dk).
 */
void dvojrozmernaPole(void)
{
  // neinicializovan dvojrozmrn pole o M dcch a N sloupcch
  int matice1[M][N];
  tiskMatice(matice1, M);

  // pouit iniciliztor pro dvojrozmrn pole MxN (tedy 7x5)
  // vimnte si rznch zpsob inicializace v jednotlivch dcch
  int matice2[M][N] = {
    { 0, 1, 2, 3, 4 },
    { 0 },
    { [3]=1 },
    { 1, [3]=1, 7 },
    { 5 },
    // posledn dva vynechm pln, protoe je to uvnit inicializtoru
    // budou naplnny nulami
  };
  tiskMatice(matice2, M);
}

/////////////////////////////////////////////////////////////////////////////
// POZOR //// POZOR //// POZOR //// POZOR //// POZOR //// POZOR //// POZOR //
/////////////////////////////////////////////////////////////////////////////
// Pole vytven v pedchozch ukzkch NELZE pouvat jako nvratov hodnoty
// funkc. Nelze ani vytvoit funkci, kter by mla jako nvratov typ tento
// druh pol. Pro tyto ely se v jazyce C pouvaj dynamicky alokovan pole
// a ukazatele.
/////////////////////////////////////////////////////////////////////////////
// Tato pole rovn NELZE koprovat pomoc piazovacho opertoru. Nelze
// udlat toto: pole1 = pole2. Tuto konstrukci peklada odmtne. Koprovn
// pol je nutn dlat po prvcch pomoc pkaz pro cykly. Dvodem pro toto
// omezen je to, e si jazyk C nepamatuje dlku pol (zejmna u vcerozmrnch
// pol by to bylo implementan problematick). Je bezpenj nechat tuto
// innost na programtorovi, kter v, kam a v poli me jt a zrove ho to
// nut si uvdomit, e operace koprovn pol nen zadarmo.
/////////////////////////////////////////////////////////////////////////////

//== konec == lokln pole - inicializace a tisk na obrazovku ==

//== zatek == textov etzce ==
/**
 * Funkce vytiskne textov etzec na vstup po jednotlivch znacch, kter
 * budou pro nzornost proloeny pomlkami.
 *
 * Funkce pedpokld, e textov etzec je ukonen znakem s kdem nula.
 * Vimnte si, e se etzec pedv jako ukazatel a uvnit se s nm pracuje
 * jako s polem.
 */
void tiskPoZnacich(char *text)
{
  int i = 0;
  while (text[i] != '\0')
  {
    printf("%c-", text[i]);
    ++i;
  }
  // opravdu je na konci nula? jeslie ano, tak ji vytiskneme
  if (text[i] == 0) printf("\\0");
  // Poznmka: Znak s kdem nula zapeme v jazyce C pomoc znakov
  // konstanty '\0', ale po tisku na obrazovku bychom nic nevidli, protoe
  // tento znak nen tisknuteln. Textov etzec obsahujc opan lomtko
  // a znak '0' zde tiskneme jen pro nzornost. Funkce ze systmov knihovny
  // ukonovac znak s kdem nula nikdy netisknou. Tento speciln znak slou
  // pouze jako zarka, aby nebylo poteba nikam ukldat dlku etzc.
}

/**
 * Typ char lze vnmat i jako celoseln typ. Kadmu znaku odpovd slo,
 * neboli kd v ASCII tabulce. V jazyce C nen poteba pracn pevdt znaky
 * na kdy a opan, protoe jde o tut hodnotu.
 *
 * Tato funkce vytiskne textov etzec jako pole selnch kd, ukonen
 * prvkem s kdem nula.
 */
void tiskKodu(char *text)
{
  int i = 0;
  while (text[i] != 0)
  {
    printf("%d-", text[i]); // nyn tiskneme dekadick slo
    ++i;
  }
  // opravdu je na konci nula? jeslie ano, tak ji vytiskneme
  if (text[i] == 0) printf("%d", text[i]);
}

/**
 * Funkce pro demonstraci rznch zpsob prce s textovmi etzci.
 *
 * V jazyce C je textov etzec pole znak libovoln dlky, kter je vdy
 * ukonen znakem s kdem nula, kter slou jako zarka. Podle tohoto znaku
 * se pozn, jak je etzec dlouh, resp. kde kon. To umouje pracovat
 * s etzci libovoln dlky (nap. v Pascal si etzec svou dlku pamatuje,
 * ale me pak bt dlouh pouze 255 znak).
 */
void textoveRetezce(void)
{
  // neinicializovan ukazatel na char
  // jet to nen pouiteln jako textov etzec
  // obsahuje nespecifikovanou nhodnou adresu!
  char *text1;

  // piazen textov konstanty
  text1 = "Jedna, dve";
  printf("text1 = %s\n", text1);

  // inicializace textovou konstantou
  char *text2 = "Surio Mario Martinez Juarez jde";
  printf("text2 = %s\n", text2);

  // podvejme se na obsah etzce ble
  printf("text2 po znacich: ");
  tiskPoZnacich(text2);
  printf("\ntext2 jako pole kodu:");
  tiskKodu(text2);
  printf("\n");

  // textov etzec nen nic jinho, ne pole znak, kter m jako posledn
  // prvek znak s kdem nula
  // dky pbuznosti pol a ukazatel budou funkce, kter oekvaj jako
  // parametr textov etzec (ukazatel na char) fungovat i s polem char
  char text3[] = { 'n', 'e', 's', 'e', ' ', 'p', 'y', 't', 'e', 'l', ' ',
                   's', ' ', 'B', 'r', 'o', 'u', 'k', 'y', '\0', };
  printf("text3 = %s\n", text3);
  printf("text3 po znacich: ");
  tiskPoZnacich(text3);
  printf("\ntext3 jako pole kodu:");
  tiskKodu(text3);
  printf("\n");

  // Msto nepohodlnho inicializtoru pole lze v tomto ppad pout
  // inicializaci textovm etzcem.
  // Dojde k vytvoen novho pole a zkoprovn znak na sv msta.
  // Vimnte si, e nen poteba vyplovat dimenzi pole, ani koncovou nulu.
  // Pokud bychom ji vyplnili, mus bt konstantn etzec men, ne tento
  // rozmr, aby se do pole veel. Pokud je krat, dopln se zbytek pole
  // nulami.
  char text4[] = "nese pytel s Brouky";
  printf("text4 = %s\n", text4);
  printf("text4 po znacich: ");
  tiskPoZnacich(text4);
  printf("\ntext4 jako pole kodu:");
  tiskKodu(text4);
  printf("\n");

  // mezi ukazatelem na char a polem jsou ovem rozdly
  // 1. ukazatel lze koprovat, ale nekopruje se etzec, pouze ukazatel na nj
  //    pvodn etzec zstv na svm mst
  char text5[] = "IIIIIII";
  char *text6 = text5;
  printf("\nkopie ukazatele\n");
  printf("text5 = %s\n", text5);
  printf("text6 = %s\n", text6);

  // 2. pole nelze koprovat
  // zkuste to odkomentovat, uloit a peloit
  // text5 = text6;    // tohle nejde, peklada ohls chybu pi pekladu

  // 3. v poli lze mnit prvky podle libosti
  text5[3] = 'X'; // zmna se projev i v text6, protoe ukazuje na text5
  printf("zmena prvku pole\n");
  printf("text5 = %s\n", text5);
  printf("text6 = %s\n", text6);

  // 4. pokud ukazatel ukazuje na pole, lze pes nj mnit prvky
  text6[2] = 'x'; text6[4] = 'x';
  printf("zmena prvku pole pres ukazatel\n");
  printf("text5 = %s\n", text5);
  printf("text6 = %s\n", text6);

  //5. pokud ukazatel ukazuje na konstantn textov etzec, prvky mnit NEJDOU
  text6 = "OOOOOOO";
  // zkuste to odkomentovat, uloit, peloit a spustit
  //text6[3] = 'I'; // tohle jde peloit, ale program by tady HAVAROVAL
  printf("ukazatel na konstantni retezec\n");
  printf("text5 = %s\n", text5);
  printf("text6 = %s\n", text6);

}

//== konec == textov etzce ==

//== zatek == cykly ==

/**
 * Funkce pro vpoet dlky textovho etzce.
 *
 * Demonstrace cyklu while. Pokud vyhodnot podmnku jako pravdivou, vykon
 * dal iteraci cyklu. Bhem vpotu se mohou promnn testovan v podmnce
 * libovoln modifikovat. Protoe vyhodnocuje podmnku ped vlastn iterac,
 * nemus tlo cyklu probhnout ani jednou.
 *
 * TIP Vimnte si, e tato funkce se bez zvltnho oetovn sprvn vyrovn
 * i s przdnm etzcem (tedy takovm, kter obsahuje pouze ukonovac nulu).
 */
int stringLength(char *text)
{
  int length = 0;
  while (text[length] != '\0')  // dokud nejsme na konci etzce, ...
  {
    ++length;    // ... pitej jedniku
  }
  return length;
}

/**
 * Vytiskne zadan textov etzec po znacch na standardn vstup a oddkuje.
 *
 * Dal demonstrace pouit cyklu while pro prchod textovm etzcem.
 */
void printStringWhile1(char *text)
{
  int index = 0;  // definice a inicializace indexu pro pohyb poli
  while (text[index] != '\0') // ukonovac podmnka vyuv toho, e
  {                           // etzec je ukonen znakem s kdem 0
    putchar(text[index]);  // funkce putchar vytiskne prv jeden znak
    ++index;               // zv index
  }
  putchar('\n'); // oddkovn
}

/**
 * Funguje stejn jako printStringWhile1.
 *
 * Demonstrace jinho zpsobu prochzen textovm etzcem.
 * TIP: Tento algoritmus mete brt jako vzor.
 * TIP: Pokud tomuto algoritmu zatm nejste schopni porozumt, nevad.
 *      Peskote jej a vrate se k nmu pozdji.
 */
void printStringWhile2(char *text)
{
  int index = 0;
  int znak = 0;  // pozor! opravdu je zde int, nikoli char
  // (znak = text[index++])
  // - piad promnn znak z pole text na indexu index a pot zv hodnotu
  //   promnn index o jedniku -- podvejte se do uebnice jazyka C na
  //   vysvtlen opertoru ++
  // - cel piazovac vraz mus bt v zvorce, protoe jeho vsledek
  //   nsledn porovnvme se znakem '\0'
  while ((znak = text[index++]) != '\0')
  {
    putchar(znak); // vytiskne jeden znak na standardn vstup
  }
  putchar('\n'); // oddkovn
}

/**
 * Funguje stejn jako printStringWhile1.
 *
 * Pro pochopen tohoto kdu je nutn znalost prce s ukazateli a znalost
 * vztahu mezi ukazatelem, polem a opertorem ++.
 * POZOR! Nepouvejte kd, o kterm si nejste jisti, jak funguje. Pedchoz
 *        ukzky jsou dkazem, e stejnou vc lze naprogramovat vce zpsoby.
 *        Tento zpsob je sice o trochu efektivnj, ne ty pedchoz, ale
 *        zase je mnohem he pochopiteln. Pokud nco takovho pouijete
 *        v projektu do njakho kurzu programovn, je tm jist, e
 *        cvic bude pi obhajob chtt, a podrobn vysvtlte, jak to
 *        funguje.
 */
void printStringWhile3(char *text)
{
  while(*text != 0)
  {
    putchar(*text++);
  }
  putchar('\n'); // oddkovn
}

/**
 * Funguje stejn jako printStringWhile1.
 *
 * Tato funkce pouze demonstruje, e v jazyce C jsou vechny tyty cykl
 * vzjemn pevoditeln. Cyklus typu do-while se pli nehod pro prci
 * s poli a textovmi etzci, protoe jeho tlo vdy probhne alespo
 * jednou. Abychom oetili situaci, kdy je poteba zpracovat przdn etzec,
 * musme si pomoci dodatenou podmnkou if.
 * Podmnka cyklu se vyhodnot po proveden jedn iterace. Cyklus provede dal
 * iteraci, pokud je podmnka pravdiv.
 *
 * TIP: Vimnte si formtovn pkazu do-while v tto ukzce. Toto formtovn
 *      minimalizuje monost zmny s cyklem while s przdnm tlem.
 */
void printStringDoWhile(char *text)
{
  int index = 0;
  int znak = text[index];
  if (znak != '\0')
  {
    do { // Pozor na poad jednotlivch pkaz. Prohodme-li nsledujc ti
         // dky, bude to fungovat chybn.
      putchar(znak);
      ++index;
      znak = text[index];
    } while (znak != '\0'); // POZOR! Zde mus bt stednk
  }
  putchar('\n'); // oddkovn
}

/**
 * Funguje stejn jako printStringWhile1.
 *
 * Demonstrace pouit cyklu for. Cyklus for je v jazyce C velmi univerzln
 * (v jazyce C lze vechny typy cykl vzjemn pevst). Cyklus m v kulatch
 * zvorkch ti vrazy oddlen pomoc stednk. Pro sprvnou innost je
 * nutn pochopit, v jakm poad se tyto vrazy vyhodnocuj. Pro pochopen
 * pome toto schma: for (inicializace; podmnka; modifikace) { tlo }
 * Postup vpotu je nyn takov:
 * 1. inicializace provede se PRV JEDNOU
 * 2. vyhodnocen podmnky, pokud je pravdiv, provede tlo, jinak cyklus kon
 * 3. provede se tlo
 * 4. vykon se st modifikace, kde se obvykle modifikuje dc promnn
 *    cyklu, pot se pejde opt na vyhodnocen podmnky
 * Kterkoli z tchto ty st me zstat przdn
 */
void printStringFor(char *text)
{
  for (int index; text[index] != '\0'; ++index)
  {
    putchar(text[index]);
  }
  putchar('\n'); // oddkovn
}

/**
 * Funguje stejn jako printStringFor.
 *
 * Naivn a nevhodn implementace vyuvajc funkci strlen pro zjitn
 * dlky etzce. Nevhodn je proto, e vpoet dlky etzce vyaduje
 * prchod celm etzcem, a kdy se toto dje v cyklu, msto N iterac
 * se provede NxN iterac (kde N je dlka etzce). V tomto ppad by bylo
 * lep uloit vsledek funkce strlen do pomocn promnn a tu pak pouvat.
 * Jet lep een je demonstrovno ve funkci printStringFor - pro prchod
 * etzcem vbec nepotebujeme znt jeho dlku.
 *
 * TIP: Pi pouit funkc uvnit cyklu se vdy zamyslete nad tm, jak tyto
 *      funkce funguj a jestli tu akci nesta udlat pouze jednou.
 */
void printStringForNaive(char *text)
{
  for (unsigned int index = 0; index < strlen(text); ++index)
  {
    putchar(text[index]);
  }
  putchar('\n'); // oddkovn
}

/**
 * Oto poad znak v textovm etzci. Postupn prohazuje prvn znak
 * s poslednm, druh s pedposlednm, atd.
 *
 * V cyklu for (ostatn jako i v ostatnch cyklech) se me vyskytovat vce
 * dcch promnnch.
 */
void otocRetezec(char *text)
{
  // v inicializan sti lze definovat a inicializovat i nkolik loklnch
  // promnnch, zde left a right jsou indexy do textovho etzce
  // v sti modifikace lze modifikovat i vce promnnch, jednotliv
  // vrazy v tto sti jsou oddleny rkou (opertor rka, viz uebnice)
  for (int left = 0, right = strlen(text) - 1; left < right ; ++left, --right)
  { // v tle provede zmnu dvou znak v etzci
    char tmp = text[left];
    text[left] = text[right];
    text[right] = tmp;
  }
}

/**
 * Funkce pro demonstraci rznch typ cykl v jazyce C.
 */
void cykly(void)
{
  printf("*** cyklus while ***\n");
  char *veta = "Ententyky, dve hmozdinky, mlady muz sel z metra.";
  printf("veta = %s\n", veta);
  printf("printStringWhile1: ");
  printStringWhile1(veta);
  printf("printStringWhile2: ");
  printStringWhile2(veta);
  printf("printStringWhile3: ");
  printStringWhile3(veta);

  printf("*** cyklus do-while ***\n");
  printf("printStringDoWhile: ");
  printStringDoWhile(veta);

  printf("*** cyklus for ***\n");
  printf("printStringFor: ");
  printStringFor(veta);
  printf("printStringForNaive: ");
  printStringForNaive(veta);

  char palindrom[] = "kobyla ma maly bok";
  printf("palindrom = %s\n", palindrom);
  otocRetezec(palindrom);
  printf("otocRetezec(palindrom): %s\n", palindrom);
}

//== konec == cykly ==


///////// Funkce main /////////////////////////////////////////////////////////

/**
 * Hlavn funkce programu. Zde se nachz startovac bod programu. Funkce
 * main se spust jako prvn pi sputn peloenho programu. Z tto funkce
 * se volaj vechny ostatn podprogramy.
 *
 * V tomto ppad jde o funkci bez parametr (to k klov slovo void),
 * kter vrac hodnotu typu int. Podle tto hodnoty operan systm, kter
 * tuto funkci zavolal, pozn, zda program skonil bez problm nebo jestli
 * nedolo k njak chyb.
 */
int main(void)
{
  printf("=== funkce tiskPoleMocnin ===\n");
  tiskPoleMocnin();

  printf("=== funkce tiskniLany ===\n");
  tiskniLany();

  printf("=== funkce dvojrozmernaPole ===\n");
  dvojrozmernaPole();

  printf("=== funkce textoveRetezce ===\n");
  textoveRetezce();

  printf("=== funkce cykly ===\n");
  cykly();

  return EXIT_SUCCESS;  // program kon bez chyby
}
